Centos7 安装python3详细教程,解决升级后不兼容问题

本文参考资料:https://www.cnblogs.com/leon-zyl/p/8422699.html,https://blog.csdn.net/tpc1990519/article/details/77856399

一、确实当前python版本

[root@centos Python-3.6.1]# python
Python 2.7.5 (default, Nov  6 2016, 00:28:07) 
[GCC 4.8.5 20150623 (Red Hat 4.8.5-11)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> 

以上输出Python
2.7.5表示当前版本,因为yum使用的是Python2.7因此不能删除,所以只能重新安装一个替换版本。
输入以下命令查看目前系统使用的Python以及安装目录,接下来将要对该目录下的Python进行修改

[root@centos ~]# which python
/usr/bin/python
[root@centos ~]# ll /usr/bin/python*
lrwxrwxrwx. 1 root root    7 May 30 05:52 /usr/bin/python -> python2
lrwxrwxrwx. 1 root root    9 May 30 05:52 /usr/bin/python2 -> python2.7
-rwxr-xr-x. 1 root root 7136 Nov  6  2016 /usr/bin/python2.7

 

二、下载安装

官网下载需要的Python版本,通过
WinSCP(安装使用教程)将下载的Python文件上传到服务器目录

  1. 解压Python安装包
    tar -zxvf Python-3.6.1.tgz
  2. 解压后进到Python根目录查看README文件,里面介绍了安装方法,这里跳过test步骤

图片 1

Paste_Image.png

根据文档介绍执行第一步./configure
–prefix=/usr/local/python3,后面添加参数为Python安装目录,默认安装目录为/usr/local/,如果出现以下错误提示则表示系统没有安装gcc
configure: error: no acceptable C compiler found in $PATH
安装gcc重新执行./configure –prefix=/usr/local/python3即可

[root@centos Python-3.6.1]# yum install gcc
[root@centos Python-3.6.1]# ./configure –prefix=/usr/local/python3

./configure
–prefix=/usr/local/python3运行成功后继续下面的命令,跳过test
make #编译
make install #安装
安装成功后在/usr/local/python3/bin目录下执行python3.6,出现如下输出证明Python已经安装成功可以用了

[root@centos python3]# python3.6 
Python 3.6.1 (default, Jun  3 2017, 07:13:03) 
[GCC 4.8.5 20150623 (Red Hat 4.8.5-11)] on linux
Type "help", "copyright", "credits" or "license" for more information.
>>> 

1、可利用linux自带下载工具wget下载,如下所示:(

三、替换旧Python

第一步已经确认当前使用Python为2.7.5并且在/usr/bin目录下,接下来需要做的就是替换/usr/bin/python,并更改yum使用的解释器,不然yum将无法使用
1 重命名当前Python,结果如下

图片 2

Paste_Image.png

2 新建Python3.6的软连接到/usr/bin/python,建好后查看已经存在,并指向正确

[root@centos bin]# ln -s /usr/local/python3/bin/python3.6 /usr/bin/python
[root@centos bin]# ll /usr/bin/python                                    
lrwxrwxrwx. 1 root root 32 Jun  4 23:29 /usr/bin/python -> /usr/local/python3/bin/python3.6

3 直接输入Python查看版本,此时已是3.6.1

图片 3

Paste_Image.png

图片 4

四、解决升级Python后yum,Firewall等不能用的问题

1、 升级Python后运行yum会报错

图片 5

Paste_Image.png

vi /user/bin/yum 编辑yum的执行文件,更改首行的/usr/bin/python
为上面重命名的名字或/usr/bin/目录下指向Python2.7的名字,之后再运行yum就正常了

图片 6

Paste_Image.png

图片 7

Paste_Image.png

2、 运行yum安装其他软件可能出现以下错误,这也是因为Python版本问题,
vi /usr/libexec/urlgrabber-ext-down
修改第一行的Python为重命名的名字(指向python2.7的)

File "/usr/libexec/urlgrabber-ext-down", line 28
   except OSError, e:
                 ^

3、防火墙无法启动

图片 8

Paste_Image.png

出现以上情况根据提示修改/usr/bin/firewall-cmd文件,顺便将同目录下的firewall-offline-cmd文件进行修改,修改后执行启动防火墙命令,会发现依然无法使用

[root@centos ~]# systemctl start firewalld.service
Job for firewalld.service failed because the control process exited with error code. See "systemctl status firewalld.service" and "journalctl -xe" for details.```
根据提示执行systemctl status firewalld.service命令查看状态,根据显示中红色部分可以看到,在执行/usr/sbin/firewalld文件时出现问题,因为查看改文件

![Paste_Image.png](http://upload-images.jianshu.io/upload_images/6259206-24058c1d19fffa28.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
可以看到这个文件也是用Python编译的,所以也要修改
`vi /usr/sbin/firewalld` 

笔者安装的是最小centos系统,所以使用编译命令前,必须安装wget服务,读者如果安装的是界面centos系统,或者使用过编译工具则可跳过安装wget,直接进行下边的编译步骤

!/usr/bin/python -Es

wget http://www.python.org/ftp/python/3.3.0/Python-3.3.0.tgz

– coding: utf-8 –

 

Copyright (C) 2010-2016 Red Hat, Inc.

2、下载完成后到下载目录下,解压

Authors:

tar -xzvf Python-3.3.0.tgz

Thomas Woerner twoerner@redhat.com

修改完成后再次执行启动命令就可以正常启动了,神清气爽啊,哈哈哈

[root@centos ~]# systemctl start firewalld.service
[root@centos ~]# systemctl status firewalld.service
â—� firewalld.service – firewalld – dynamic firewall daemon
Loaded: loaded (/usr/lib/systemd/system/firewalld.service; enabled;
vendor preset: enabled)
Active: active (running) since Wed 2017-06-07 05:38:13 CST; 6s ago
Docs: man:firewalld(1)
Main PID: 2481 (firewalld)
CGroup: /system.slice/firewalld.service
└─2481 /usr/bin/python2.7 -Es /usr/sbin/firewalld –nofork –nopid

Jun 07 05:38:13 centos systemd[1]: Starting firewalld – dynamic
firewall daemon…
Jun 07 05:38:13 centos systemd[1]: Started firewalld – dynamic
firewall daemon.

除此之外还有一些其他文件使用的Python,可以使用grep命令查看哪些文件使用了Python解释器,根据具体情况修改。例如查看/usr/bin目录下的文件

[root@centos ~]# grep -ai /usr/bin/python /usr/bin/*
/usr/bin/easy_install:#!/usr/bin/python
/usr/bin/easy_install-2.7:#!/usr/bin/python
/usr/bin/firewall-cmd:#!/usr/bin/python2.7 -Es
/usr/bin/firewall-offline-cmd:#!/usr/bin/python2.7 -Es
/usr/bin/msghack:#!/usr/bin/python2.7
/usr/bin/pip:#!/usr/bin/python
/usr/bin/pip2:#!/usr/bin/python
/usr/bin/pip2.7:#!/usr/bin/python
/usr/bin/pydoc:#!/usr/bin/python2.7
/usr/bin/systemd-sysv-convert:#!/usr/bin/python2.7
/usr/bin/urlgrabber:#!/usr/bin/python2.7 -t
/usr/bin/wheel:#!/usr/bin/python2.7
/usr/bin/yum:#!/usr/bin/python2“`

 图片 9

五、make install过程中出现报错解决

出现以下问题:
FAIL: test_with_pip (test.test_venv.EnsurePipTest)
zipimport.ZipImportError: can’t decompress data; zlib not available

图片 10

Paste_Image.png

图片 11

Paste_Image.png

解决办法:出现这种错误一般因为Python的安装环境没有安装好,安装以下软件
yum install openssl-devel
如果还是有报错则安装Development tools
yum groupinstall Development tools
安装成功后make clean以下,再次重复 上面操作

3、进入解压缩后的文件夹

cd Python-3.3.0  

 图片 12

图片 13

 

4、在编译前先在/usr/local建一个文件夹python3(作为python的安装路径,以免覆盖老的版本)

mkdir /usr/local/python3 
(此处新建文件夹用mkdir,如果是新建文件则用touch)

图片 14

  

5、开始编译安装(
图片 15

笔者安装的是最小centos系统,所以使用编译命令前,必须安装编译套件gcc,读者如果安装的是界面centos系统,或者使用过编译工具则可跳过安装gcc,直接进行下边的编译步骤)

./configure
–prefix=/usr/local/python3

图片 16

 

make

图片 17

 

make install

图片 18

 

 

6、此时没有覆盖老版本,再将原来/usr/bin/python链接改为别的名字(笔者保留了两个版本的,一个python,一个python3,所以第6步笔者略过,把第7步的链接后名字改为python3,读者可按正常步骤,实现的效果相同)

mv /usr/bin/python
/usr/bin/python_old2

  

7、再建立新版本python的链接

ln -s /usr/local/python3/bin/python3
 /usr/bin/python

  

8、这个时候输入

python -V

图片 19

 

10、就会显示出python的新版本信息

[idolaoxu@localhost home]# python
-V

Python 3.3.0

 

PS:如果不建立新安装路径python3,而是直接默认安装,则安装后的新python应该会覆盖linux下自带的老版本,也有可能不覆盖,具体看安装过程了,

这个大家可以自己试验下,当然如果还想保留原来的版本,那么这种方法最好不过了。

 

===========================================================================

追加部分:‘

四、解决升级Python后yum,Firewall等不能用的问题

1、 升级Python后运行yum会报错

图片 5

Paste_Image.png

vi /user/bin/yum 编辑yum的执行文件,更改首行的/usr/bin/python
为上面重命名的名字或/usr/bin/目录下指向Python2.7的名字,之后再运行yum就正常了

图片 6

Paste_Image.png

图片 7

Paste_Image.png

2、 运行yum安装其他软件可能出现以下错误,这也是因为Python版本问题,
vi /usr/libexec/urlgrabber-ext-down
修改第一行的Python为重命名的名字(指向python2.7的)

File "/usr/libexec/urlgrabber-ext-down", line 28
    except OSError, e:
                  ^ 

3、防火墙无法启动

图片 8

Paste_Image.png

出现以上情况根据提示修改/usr/bin/firewall-cmd文件,顺便将同目录下的firewall-offline-cmd文件进行修改,修改后执行启动防火墙命令,会发现依然无法使用

[root@centos ~]# systemctl start firewalld.service
Job for firewalld.service failed because the control process exited with error code. See "systemctl status firewalld.service" and "journalctl -xe" for details.

根据提示执行systemctl status
firewalld.service命令查看状态,根据显示中红色部分可以看到,在执行/usr/sbin/firewalld文件时出现问题,因为查看改文件

图片 24

Paste_Image.png

可以看到这个文件也是用Python编译的,所以也要修改“

vi /usr/sbin/firewalld

#!/usr/bin/python -Es
# -*- coding: utf-8 -*-
#
# Copyright (C) 2010-2016 Red Hat, Inc.
# Authors:
# Thomas Woerner <twoerner@redhat.com>

修改完成后再次执行启动命令就可以正常启动了,神清气爽啊,哈哈哈

[root@centos ~]# systemctl start firewalld.service 
[root@centos ~]# systemctl status firewalld.service
â—  firewalld.service - firewalld - dynamic firewall daemon
   Loaded: loaded (/usr/lib/systemd/system/firewalld.service; enabled; vendor preset: enabled)
   Active: active (running) since Wed 2017-06-07 05:38:13 CST; 6s ago
     Docs: man:firewalld(1)
 Main PID: 2481 (firewalld)
   CGroup: /system.slice/firewalld.service
           └─2481 /usr/bin/python2.7 -Es /usr/sbin/firewalld --nofork --nopid

Jun 07 05:38:13 centos systemd[1]: Starting firewalld - dynamic firewall daemon...
Jun 07 05:38:13 centos systemd[1]: Started firewalld - dynamic firewall daemon.

“除此之外还有一些其他文件使用的Python,可以使用grep命令查看哪些文件使用了Python解释器,根据具体情况修改。例如查看/usr/bin目录下的文件

[root@centos ~]# grep -ai /usr/bin/python /usr/bin/*
/usr/bin/easy_install:#!/usr/bin/python
/usr/bin/easy_install-2.7:#!/usr/bin/python
/usr/bin/firewall-cmd:#!/usr/bin/python2.7 -Es
/usr/bin/firewall-offline-cmd:#!/usr/bin/python2.7 -Es
/usr/bin/msghack:#!/usr/bin/python2.7
/usr/bin/pip:#!/usr/bin/python
/usr/bin/pip2:#!/usr/bin/python
/usr/bin/pip2.7:#!/usr/bin/python
/usr/bin/pydoc:#!/usr/bin/python2.7
/usr/bin/systemd-sysv-convert:#!/usr/bin/python2.7
/usr/bin/urlgrabber:#!/usr/bin/python2.7 -t
/usr/bin/wheel:#!/usr/bin/python2.7
/usr/bin/yum:#!/usr/bin/python2

五、make install过程中出现报错解决

出现以下问题:
FAIL: test_with_pip (test.test_venv.EnsurePipTest)
zipimport.ZipImportError: can’t decompress data; zlib not available

图片 10

Paste_Image.png

图片 11

Paste_Image.png

解决办法:出现这种错误一般因为Python的安装环境没有安装好,安装以下软件
yum install openssl-devel
如果还是有报错则安装Development tools
yum groupinstall Development tools
安装成功后make clean以下,再次重复 上面操作